import java.io.*;
import fi.jyu.mit.ohj2.*;
/**
 * Harrastus joka osaa mm. itse huolehtia tunnus_nro:staan.
 *
 * @author Vesa Lappalainen
 * @version 1.0, 20.03.2003
 */
public class Harrastus {
  private int    tunnus_nro;
  private int    jasen_id;
  private String ala;
  private int    aloitusvuosi;
  private int    tuntia_viikossa;

  private static int seuraava_nro = 1;

  public Harrastus() {  }

  /**
   * Apumetodi, jolla saadaan tytetty testiarvot Harrastukselle.
   * Aloitusvuosi arvotaan, jotta kahdella harrastuksella ei olisi
   * samoja tietoja.
   * @param jid viite henkiln, jonka harrastuksesta on kyse
   */
  void vastaa_pitsin_nyplays(int jid) {
     jasen_id = jid;
     ala = "Pitsin nyplys";
     aloitusvuosi = Jasen.rand(1900,2000);
     tuntia_viikossa = Jasen.rand(0,60);
  }
  /**
   * Tulostetaan harrastuksen tiedot
   * @param out tietovirta johon tulostetaan
   */
  public void tulosta(PrintStream out) {
    out.println(ala + " " + aloitusvuosi + " " + tuntia_viikossa);
  }

  /**
   * Tulostetaan henkiln tiedot
   * @param os tietovirta johon tulostetaan
   */
  public void tulosta(OutputStream os) {
    tulosta(new PrintStream(os));
  }

  /**
   * Antaa harrastukselle seuraavan rekisterinumeron.
   * @return harrastuksen uusi tunnus_nro
   */
  public int  rekisteroi() {
    tunnus_nro = seuraava_nro;
    seuraava_nro++;
    return tunnus_nro;
  }

  public int getTunnus_nro() { return tunnus_nro; }
  public int getJasen_id() { return jasen_id; }

  /**
   * Testiohjelma Harrastukselle.
   * @param args ei kytss
   */
  public static void main(String args[]) {
    Harrastus har = new Harrastus();
    har.vastaa_pitsin_nyplays(2);
    har.tulosta(System.out);
  }

}


