import java.util.Iterator;
/**
 * Kerho-luokka, joka huolehtii jsenistst.  Posin kaikki metodit
 * ovat vain "vlittjmetodeja" jsenistn tai harrastuksiin.
 *
 * @author Vesa Lappalainen
 * @version 1.0, 09.02.2003
 * @version 1.1, 23.02.2003
 * @version 1.2, 20.03.2003
 */
public class Kerho {
  private Jasenet jasenet = new Jasenet();
  private Harrastukset harrastukset = new Harrastukset();

  public String getNimi() { return jasenet.getKoko_nimi(); }
  public int getJasenia() { return jasenet.getLkm();       }

  /**
   * Poistaa jsenistst ja harrasteista ne joilla on valittu id. Kesken.
   * @param id viitenumero, jonka mukaan poistetaan
   * @return montako jsent poistettiin
   */
  public int poista(int id)              { return 0;                          }

  public boolean TeeBak(String bak_tark) { return jasenet.TeeBak(bak_tark);   }
  public String getTiedoston_nimi()      { return jasenet.getTiedoston_nimi();}
  public String getBak_nimi()            { return jasenet.getBak_nimi();      }
  public void lisaa(Jasen jasen) throws Jasenet.SailoException
                                         { jasenet.lisaa(jasen);              }
  public void lisaa(Harrastus har)       { harrastukset.lisaa(har);           }

//  public Jasen anna_jasen(int i) throws Jasenet.SailoException
//                                         { return jasenet.anna(i);            }
  public Iterator jasen_iterator()         { return jasenet.iterator();       }
  public Iterator harrastus_iterator()     { return harrastukset.iterator();  }
  public Iterator harrastus_iterator(int jid) { return harrastukset.iterator(jid);}


  public void lue_tiedostosta(String nimi) throws Jasenet.SailoException {
    jasenet.lue_tiedostosta(nimi);
  }

  public void talleta() throws Jasenet.SailoException {
    jasenet.talleta();
  }

  public static void main(String args[]) {
    Kerho kerho = new Kerho();

    try {
      kerho.lue_tiedostosta("kelmit");

      Jasen aku = new Jasen(), aku2 = new Jasen();
      aku.rekisteroi();    aku.vastaa_aku_ankka();
      aku2.rekisteroi();   aku2.vastaa_aku_ankka();

      kerho.lisaa(aku);
      kerho.lisaa(aku2);

      System.out.println("============= Kerhon testi =================");

      for (Iterator i=kerho.jasen_iterator(); i.hasNext(); ) {
        Jasen jasen = (Jasen)i.next();
        System.out.println("Jsen nro: " + i);
        jasen.tulosta(System.out);
      }

    } catch ( Jasenet.SailoException ex ) {
      System.out.println(ex.getMessage());
    }
  }


}


